/**
 * @file SensorFSM.h
 * @author your name (you@domain.com)
 * @brief 
 * @version 0.1
 * @date 2022-09-02
 * 
 * @copyright Copyright (c) 2022
 * 
 */

#ifndef __SENSOR_FSM_H
#define __SENSOR_FSM_H

#include "stdint.h"
#include "stdbool.h"

#define SENSOR_NUMBER_MAX 6

#define SENSOR_RESTART_TIMEOUT (3 * 60 * 60 *1000)

typedef enum
{
    SEN_STATE_IDLE = 0,
    SEN_STATE_COLLECTING,
    SEN_STATE_COMPLETED,
    SEN_STATE_ERROR,
    SEN_STATE_RECALCULATE,      // 老传感器没有转速同步
		SEN_STATE_READERROR,
		SEN_IVLSTATE_ERROR,

    SEN_STATE_MAX
} sen_state_t;

typedef struct
{
    // sen_state_t tostate;
    sen_state_t state;
    bool bmotor;
    uint32_t addr;
    bool available;
    uint32_t u32SensorStateErrCnt;
    uint32_t errRestartTick;
    uint32_t errLastUpdateTick;
}sensorFSM_t;


void sensorInit(void);

void sensorProcess(void);

sen_state_t sensorStateGet(unsigned int idx);

bool sensorAvailableGet(uint32_t idx);

void sensorAvailableSet(uint32_t idx, bool state);

uint32_t sensorsAvailableStateGet(void);

void sensorsAvailableStateSet(uint32_t available);

#endif
