#ifndef __BLE_CLIENT__H__
#define __BLE_CLIENT__H__

#include "nvs_flash.h"
#include "stdbool.h"
/* BLE */
#include "nimble/nimble_port.h"
#include "nimble/nimble_port_freertos.h"
#include "freertos/semphr.h"
#include "host/ble_hs.h"
#include "host/util/util.h"
#include "console/console.h"
#include "services/gap/ble_svc_gap.h"
#include "modlog/modlog.h"
#include "blecent.h"
#include "sdkconfig.h"
#include "wcp.h"
#include "wit.h"


#define WIT_COMPLETE_FUN_CODE                       0x0000  

typedef struct {
    uint16_t              addr;
    uint16_t              group;
    uint16_t              handle;
    bool                  bIsFind;
    bool                  bIsConnect;
    bool                  bDeliveries;
    struct peer           *peer;
    const struct peer_chr *sensor_chr;
    unsigned int          gtms;
    unsigned long         ulVirAddr;
    signed  char          rssi;
    char                  senCode;
    char                  cComplete;
} sDevInfo;

typedef struct {
   sDevInfo xDevInfo[WIT_SENSOR_MAX_CONNECT_NUM * WIT_SENSOR_GROUP_MAX_NUM];
   unsigned long ulConnnectBit; 
} sSenInfo;

typedef enum {
    OPERATE_INDICATE = 0,
    OPEN_CONNECT
} action_class;

#define   BLE_DEBUG_ENABLE      1

bool            ble_client_init(void);
void            ble_clear_dev_info(void);
void            ble_clear_info_from_index(int index);
sDevInfo*       ble_find_dev_from_addr(unsigned short usAddr);
sDevInfo*       ble_find_dev_from_group(unsigned short usGroup);
unsigned long   getBLEConnectNum(void);
bool            ble_sensor_write(int index, void *buf, size_t len);
bool            ble_sensor_indicate(int index, void *buf, size_t len);
bool            send_update_bin(int index);
void            ble_set_CheckTime(bool status);
void            ble_clear_dev_complete(void);
#endif
