#ifndef __WCP_H__
#define __WCP_H__

#ifdef __cplusplus
extern "C"
{
#endif

#include "fsad.h"
#include "stdbool.h"
#include "stddef.h"

#define   BLE_CHR_HANDLER_NUM              1
#define   SENSOR_CHR_WRITE_HANDLER         0

#define   APKG_EVENT_BIT                   1

#define   APKG_TIME_OUT                    (6 * 1000)
#define   APKG_FREE_SIZE_TIME_OUT          (2 * 1000)
#define   APKG_UNSIGNED_CHAR_MAX_NUM       470
#define   APKG_BLE_MTU_MAX_SIZE            495

typedef enum {
 APKG_MASTER = 0,
 APKG_SALVE
} eTies;

typedef struct 
{
    unsigned int   uiDevice;
    unsigned short usType;
    unsigned short size;
    char  buf[APKG_BLE_MTU_MAX_SIZE];
}sBuf;

void            wcp_init(eTies eis);
void            wcp_data_migration(unsigned int uiIndex, unsigned short usType, unsigned char *buf, unsigned short size);
void            wcp_set_event_bit(void);
eWCPinfo        eWCPReadDataAddress(int index, const unsigned short ucWCPtype, const unsigned int usStartCode, const unsigned int usAddrNumber, unsigned char *usData);
eWCPinfo        eWCPWriteDataAddress(int index, const unsigned short ucWCPtype, unsigned int usStartCode, const unsigned int usAddrNumber, void* vData);

#ifdef __cplusplus
}
#endif

#endif
