#ifndef __FLASH_H__
#define __FLASH_H__

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include "esp_err.h"

typedef enum {
    E_GW_CONFIG = 0,         //  网关配置缓存
    E_GWBP_CONFIG,           //  网关备份配置缓存
    E_SEN_CONFIG,            //  传感器配置缓存
    E_SENBP_CONFIG,          //  传感器备份配置缓存
    E_PVD_STORE,             //  pvd数据缓存
    E_THRESHOLD_STORE,       //  特征值阈值缓存
    E_THRESHOLD_BP_STORE,    //  特征值阈值备份缓存
    E_THRESHOLD_FLAG,        //  特征阈值初始化标志
    E_FEA_HISTORY_STORE,
    E_FEA_HISTORY_FLAG,
    E_FEATURE_STORE,         //  网关特征存储区域
    E_SEN_FEA1_STORE,        //  传感器1特征存储区域
    E_SEN_FEA2_STORE,        //  传感器2特征存储区域
    E_SEN_FEA3_STORE,        //  传感器3特征存储区域
    E_SEN_FEA4_STORE,        //  传感器4特征存储区域
    E_SEN_FEA5_STORE,        //  传感器5特征存储区域
    E_SEN_FEA6_STORE         //  传感器6特征存储区域
} EFLASH_TYPE;

void flash_semphr_init(void);
void write_flash(EFLASH_TYPE eft, const void *data, const size_t size);
void read_flash(EFLASH_TYPE eft, void *data, const size_t size);
esp_err_t read_ble_bin(char *data, size_t offset, size_t size);
esp_err_t write_ble_bin(char *data, size_t offset, size_t size);
void erase_bin(void);
bool getFalshStatus(void);
void setFlashStatus(bool bStatus);

#ifdef __cplusplus
}
#endif

#endif