#ifndef __RAM_H__
#define __RAM_H__

#ifdef __cplusplus
extern "C"
{
#endif

#define  WAVE_MAX_SIZE       50000
#define  FEATURE_MAX_SIZE    1024

typedef struct {
   unsigned char cWave[WAVE_MAX_SIZE];
}dev_wave;

typedef struct {
   unsigned char cFeature[FEATURE_MAX_SIZE];
}dev_feature;

void ram_init(void);

dev_wave         *get_dev_wave(unsigned int index);
dev_feature      *get_dev_fea(unsigned int index);
void             write_ram_wave(unsigned int uiSensorID, unsigned long index, unsigned char *pucWriteBuffer, unsigned long ulSize);
void             read_ram_wave(unsigned int uiSensorID, unsigned long index, unsigned char *pucReadBuffer, unsigned long ulSize);
void             write_ram_feature(unsigned int uiSensorID, unsigned long index, unsigned char *pucWriteBuffer, unsigned long ulSize);
void             read_ram_feature(unsigned int uiSensorID, unsigned long index, unsigned char *pucReadBuffer, unsigned long ulSize);
void             write_mqtt_wave_data(unsigned long index, unsigned char *pucWriteBuffer, unsigned long ulSize);
void             read_mqtt_wave_data(unsigned long index, unsigned char *pucReadBuffer, unsigned long ulSize);
void             write_mqtt_feature_data(unsigned long index, unsigned char *pucWriteBuffer, unsigned long ulSize);
void             read_mqtt_feature_data(unsigned long index, unsigned char *pucReadBuffer, unsigned long ulSize);

#ifdef __cplusplus
}
#endif

#endif