#ifndef __SPI_H__
#define __SPI_H__

#ifdef __cplusplus
extern "C"
{
#endif

#include "driver/spi_master.h"
#include "driver/gpio.h"

#define SPI_MODE_0					0
#define SPI_MODE_1					1
#define SPI_MODE_2					2
#define SPI_MODE_3					3

//SPI Perscaler
#define SPI_PRESCALER_1 			SPI_MASTER_FREQ_80M
#define SPI_PRESCALER_2 			SPI_MASTER_FREQ_40M
#define SPI_PRESCALER_3 			SPI_MASTER_FREQ_26M
#define SPI_PRESCALER_4 			SPI_MASTER_FREQ_20M 
#define SPI_PRESCALER_5 			SPI_MASTER_FREQ_16M 
#define SPI_PRESCALER_6 			SPI_MASTER_FREQ_13M 
#define SPI_PRESCALER_7 			SPI_MASTER_FREQ_11M
#define SPI_PRESCALER_8 			SPI_MASTER_FREQ_10M
#define SPI_PRESCALER_9 			SPI_MASTER_FREQ_9M
#define SPI_PRESCALER_10 			SPI_MASTER_FREQ_8M 

//Others
#define DUMMY_DATA					0xFF
#define SPI_DUMMY_DATA				DUMMY_DATA

void spi_init(unsigned long ulPrescaler);
void spi_send_byte(uint32_t addrSel, uint8_t *wb, uint32_t len);
void spi_read_byte(uint32_t addrSel, uint8_t * out_data, uint32_t len);
void cs_low(void);
void cs_high(void);

#ifdef __cplusplus
}
#endif

#endif
