#ifndef ETH_H
#define ETH_H

#include <stdbool.h>
/* Exported macros -----------------------------------------------------------*/
#define ETH_MAX_MODE_SIZE				8
#define ETH_MAX_HOST_SIZE				64
#define ETH_MAX_PORT_SIZE				8

#define ETH_MAX_SOCKET_COUNT            4

/* Exported types ------------------------------------------------------------*/
typedef struct
{
	char cMode[ETH_MAX_MODE_SIZE];						//模式(TCPC TCPS UDPC UDPS HTTPC HTTPS)
	char cDestinationHost[ETH_MAX_HOST_SIZE];			//目标ip or 域名
	char cDestinationPort[ETH_MAX_PORT_SIZE];			//目标端口
	bool bStatus;										//网络是否正常
	bool bUsed;											//是否被使用
} ETHERNET_Socket;

/* Exported functions --------------------------------------------------------*/
long ETHERNET_CreateSocket(char *pcMode, char *pcHost, char *pcPort);
void ETHERNET_ReleaseSocket(unsigned long ulSocketID);
void ETHERNET_SetSocketStatus(unsigned long ulSocketID, bool bStatus);
bool ETHERNET_GetSocketStatus(unsigned long ulSocketID);
void ETHERNET_SetMQTTReconnectCallBack(bool (*pFuncMQTTReconnectCallBack)(unsigned long));
void ETHERNET_SetMQTTStatusChangedCallBack(void (*pFuncMQTTStatusChangedCallBack)(unsigned long, bool));
void if_eth_task_init(void);
void setEthSocketStatus(unsigned long socket, bool status);
void setMQTTStatusChangned(unsigned long socket, bool status);
void check_eth_ping(unsigned long socket);
void check_phy(unsigned long socket);
#endif