#ifndef CELLUAR_EVNET_H
#define CELLUAR_EVNET_H
/* Includes ------------------------------------------------------------------*/
#include "common.h"
/* Exported macros -----------------------------------------------------------*/
#define CELLUAR_MAX_EVENT_NUM				11	//(11 - 1) Event size.

/* Exported types ------------------------------------------------------------*/
typedef enum
{
	Celluar_EventNetReceived		= 0,
	Celluar_EventNetClosed 			= 1,
	Celluar_EventPowerDown 			= 2,
	Celluar_EventPullCard			= 3,
	Celluar_EventPDPDeact			= 4
} Celluar_EventType;

typedef struct
{
	unsigned char *pucPayload;
	unsigned long ulLength;
} Celluar_EventMessage;

typedef struct
{
	unsigned long 			ulFront;
	unsigned long 			ulRear;
	Celluar_EventMessage 	xMessage[CELLUAR_MAX_EVENT_NUM];
	Celluar_EventType 		eEventArray[CELLUAR_MAX_EVENT_NUM];				
} Celluar_EventQueue;

/* Exported functions --------------------------------------------------------*/
void Celluar_EventPost(Celluar_EventType eEvent, unsigned char *pucData, unsigned long ulLength);
bool Celluar_EventGet(Celluar_EventType *peEvent, unsigned char **ppucData, unsigned long *pulLength);
bool Celluar_EventDel(void);

/* Event handlers ------------------------------------------------------------*/
void Celluar_EventPowerDownHandler(void);
void Celluar_EventNetClosedHandler(unsigned long ulSocketID);
void Celluar_EventNetReceivedHandler(unsigned long ulSocketID, unsigned char *pucData, unsigned long ulLength);
void Celluar_EventPullCardHandler(void);
void Celluar_EventPDPDeactHandler(void);
#endif


