#ifndef CELLUAR_QUEUE_H
#define CELLUAR_QUEUE_H
/* Includes ------------------------------------------------------------------*/
#include "celluar_config.h"
#include "common.h"

#if defined ( __CC_ARM   )
#pragma anon_unions
#endif

/* Exported macros -----------------------------------------------------------*/
#define CELLUAR_BUFFER_SIZE				(9 * 1024)
#define CELLUAR_QUEUE_SIZE				2

#define CELLUAR_QUEUE_IS_MALLOC			0
/* Exported types ------------------------------------------------------------*/
//Receive buffer
typedef struct
{
#if CELLUAR_QUEUE_IS_MALLOC > 0
	union 
	{
		unsigned char *pucBuffer;
		unsigned char *ucBuffer;
	};
#else
	unsigned char ucBuffer[CELLUAR_BUFFER_SIZE];
#endif
	unsigned long ulBufferLen;
} Celluar_Buffer;

typedef struct 
{
	unsigned long 	ulFront;
	unsigned long 	ulRear;
	bool			bQueueFull;
	Celluar_Buffer 	xReceiveBuffer[CELLUAR_QUEUE_SIZE];
} Celluar_Queue;

/* Exported functions --------------------------------------------------------*/
bool Celluar_QueueIsEmpty(Celluar_Queue *pxQueue);
bool Celluar_QueueIsFull(Celluar_Queue *pxQueue);
void Celluar_QueuePush(Celluar_Queue *pxQueue);
void Celluar_QueuePop(Celluar_Queue *pxQueue);

#endif
