/* Includes ------------------------------------------------------------------*/
#include "stack.h"
#include <stdlib.h>


/**
  * @brief  create stack
  * @param  size
  * @retval stack
  */
Stack Stack_Create(long lStackSize)
{
	Stack xStack;
	
	xStack.lTop = -1;
	xStack.pdArray = (double *)malloc(lStackSize * sizeof(double));
	if (xStack.pdArray  != NULL)
	{
		xStack.lStackSize = lStackSize;
	}
	else
	{
		xStack.lStackSize = 0;
	}
	
	return xStack;
}

/**
  * @brief  release stack
  * @param  stack
  * @retval void
  */
void Stack_Release(Stack *pxStack)
{
	pxStack->lTop = -1;
	pxStack->lStackSize = 0;
	if (pxStack->pdArray != NULL)
	{
		free(pxStack->pdArray);
	}
}

/**
  * @brief  push
  * @param  stack
  * @retval void
  */
void Stack_Push(Stack *pxStack, double dData)
{
	if (pxStack->lTop + 1 < pxStack->lStackSize)
	{
		pxStack->pdArray[++pxStack->lTop] = dData;
	}
}

/**
  * @brief  pop
  * @param  stack
  * @retval void
  */
double Stack_Pop(Stack *pxStack)
{
	if (pxStack->lTop >= 0)
	{
		return pxStack->pdArray[pxStack->lTop--];
	}
	
	return 0;
}

/**
  * @brief  peek
  * @param  stack
  * @retval void
  */
double Stack_Peek(Stack *pxStack)
{
	if (pxStack->lTop >= 0)
		return pxStack->pdArray[pxStack->lTop];
	
	return 0;
}

/**
  * @brief  is empty
  * @param  stack
  * @retval void
  */
bool Stack_IsEmpty(Stack *pxStack)
{
	if (pxStack->lTop < 0)
		return true;
	
	return false;
}
